<template>
    <v-app >
       <v-main>
          <v-container fluid fill-height>
             <v-layout align-center justify-center>
                <v-flex xs12 sm8 md4>
                   <v-card class="elevation-12">
                      <v-toolbar dark color="primary">
                         <v-toolbar-title>Login form</v-toolbar-title>
                      </v-toolbar>
                      <v-card flat tile>
                        <v-card-text>

                           <v-alert
                              density="compact"
                              :text="notification"
                              title="Alert title"
                              :type="actionClass"
                              v-if="notification"
                           >
                           {{  notification  }}

                        </v-alert>
                        </v-card-text>
                      </v-card>
                      <v-card-text>
                      <form ref="form" @submit.prevent="login()">
                             <v-text-field
                               v-model="username"
                               name="username"
                               label="Username"
                               type="text"
                               placeholder="username"
                               required
                            ></v-text-field>

                             <v-text-field
                               v-model="password"
                               name="password"
                               label="Password"
                               type="password"
                               placeholder="password"
                               required
                            ></v-text-field>
                            <v-btn type="submit" class="mt-4" color="primary" value="log in">Login</v-btn>
                       </form>

                       <div class="grey--text mt-4" >
                              Don't have an account? Register
                           </div>
                      </v-card-text>
                   </v-card>

                </v-flex>
             </v-layout>
          </v-container>
       </v-main>
    </v-app>
 </template>

<script>
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex';

export default {
  name: 'Login',
  data() {
    return {
      username: '',
      password: '',
      notification: null,
      actionClass: null,
    };
  },
  computed: {
    ...mapState(['token']),
    ...mapGetters(['isAuthenticated']),
  },
  methods: {
    ...mapMutations(['setAccessToken']),
    ...mapActions(['axiosPostRequest']),

    async login() {
      const { username } = this;
      const { password } = this;

      const payload = {
        username,
        password,
      };

      const fullPayload = {
        params: payload,
        endpoint: '/auth/login',
      };
      try {
        const res = await this.axiosPostRequest(fullPayload);
        this.notification = res.status === 200 ? 'Login successful' : res.data.message;
        const { token } = res.data;

        this.setAccessToken(token);

        localStorage.setItem('jwtToken', token);

        this.actionClass = res.status === 200 ? 'success' : 'error';
        this.$router.push('/');
      } catch (error) {
        this.notification = 'Login failed. Contact the admin';
        this.actionClass = 'error';
        return error.response;
      }
    },
  },
};
</script>
